# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Icon(pulumi.CustomResource):
    base64content: pulumi.Output[str]
    """
    The base64 encoded content to upload to as the Icon. This conflicts with [`source`]
    """
    name: pulumi.Output[str]
    """
    The name of the Icon. The length of this value must be in the range [`1`-`64`]
    """
    source: pulumi.Output[str]
    """
    The file path to upload to as the Icon. This conflicts with [`base64content`]
    """
    tags: pulumi.Output[list]
    """
    Any tags to assign to the Icon
    """
    url: pulumi.Output[str]
    """
    The URL for getting the icon's raw data
    """
    def __init__(__self__, resource_name, opts=None, base64content=None, name=None, source=None, tags=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a Icon resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] base64content: The base64 encoded content to upload to as the Icon. This conflicts with [`source`]
        :param pulumi.Input[str] name: The name of the Icon. The length of this value must be in the range [`1`-`64`]
        :param pulumi.Input[str] source: The file path to upload to as the Icon. This conflicts with [`base64content`]
        :param pulumi.Input[list] tags: Any tags to assign to the Icon
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['base64content'] = base64content
            __props__['name'] = name
            __props__['source'] = source
            __props__['tags'] = tags
            __props__['url'] = None
        super(Icon, __self__).__init__(
            'sakuracloud:index/icon:Icon',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, base64content=None, name=None, source=None, tags=None, url=None):
        """
        Get an existing Icon resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] base64content: The base64 encoded content to upload to as the Icon. This conflicts with [`source`]
        :param pulumi.Input[str] name: The name of the Icon. The length of this value must be in the range [`1`-`64`]
        :param pulumi.Input[str] source: The file path to upload to as the Icon. This conflicts with [`base64content`]
        :param pulumi.Input[list] tags: Any tags to assign to the Icon
        :param pulumi.Input[str] url: The URL for getting the icon's raw data
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["base64content"] = base64content
        __props__["name"] = name
        __props__["source"] = source
        __props__["tags"] = tags
        __props__["url"] = url
        return Icon(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

